



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>vue特殊属性 key ref slot</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">vue特殊属性 key ref slot</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-29 07:21:34 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>1.key</h2>
<p>当使用key时，必须设置兄弟元素唯一的key，当key排列顺序变化时，兄弟元素会重新排列，而当key的值变化时，这个元素会被重新渲染。</p>
<p>有相同父元素的子元素必须有独特的 key。重复的 key 会造成渲染错误。</p>
<p>例子&nbsp;v-if中用 key 管理可复用的元素</p>
<p>允许用户在不同的登录方式之间切换:</p>
<div>
<pre class="prettyprint linenums">&lt;template&gt;<br />
  &lt;div id="app"&gt;<br />
    &lt;button @click="changeState"&gt;切换&lt;/button&gt;<br />
    &lt;template v-if="loginType==='username'"&gt;<br />
      &lt;label&gt;username&lt;/label&gt;<br />
      &lt;input type="text" placeholder="输入username"&gt;<br />
    &lt;/template&gt;<br />
    &lt;template v-else&gt;<br />
      &lt;label &gt;email&lt;/label&gt;<br />
      &lt;input type="text" placeholder="输入email"&gt;<br />
    &lt;/template&gt;<br />
  &lt;/div&gt;<br />
&lt;/template&gt;

&lt;script&gt;<br />
export default {<br />
  data(){<br />
    return{<br />
      loginType:'username'<br />
    }<br />
  },<br />
  methods:{<br />
    changeState(){<br />
      this.loginType='email'<br />
    }<br />
  }<br />
}<br />
&lt;/script&gt;</pre>
</div>
<p>那么在上面的代码中切换 loginType 将不会清除用户在input里面已经输入的内容。因为两个模版使用了相同的元素，&lt;input&gt; 不会被替换掉&mdash;&mdash;仅仅是替换了它的 placeholder。<br />这样也不总是符合实际需求，所以 Vue 为你提供了一种方式来声明&ldquo;这两个元素是完全独立的&mdash;&mdash;不要复用它们&rdquo;。只需添加一个具有唯一值的 key 属性即可：</p>
<div>
<pre class="prettyprint linenums">&lt;template v-if="loginType === 'username'"&gt;<br />
  &lt;label&gt;Username&lt;/label&gt;<br />
  &lt;input type="text" placeholder="输入username" key="username-input"&gt; <br />&lt;/template&gt; <br />&lt;template v-else&gt; <br />　&lt;label&gt;Email&lt;/label&gt; <br />  &lt;input type="text" placeholder="输入email" key="email-input"&gt; <br />&lt;/template&gt;</pre>
</div>
<p>现在，每次切换时，输入框都将被重新渲染。注意, &lt;label&gt; 元素仍然会被高效地复用，因为它们没有添加 key 属性。</p>
<p>例子&nbsp;v-for中的key</p>
<p>当 Vue.js 用 v-for 正在更新已渲染过的元素列表时，它默认用 &ldquo;就地复用&rdquo; 策略。如果数据项的顺序被改变，Vue将不是移动 DOM 元素来匹配数据项的顺序， 而是简单复用此处每个元素，并且确保它在特定索引下显示已被渲染过的每个元素。这个类似 Vue 1.x 的 track-by="$index" 。<br />&nbsp; &nbsp; &nbsp; 这个默认的模式是有效的，但是只适用于不依赖子组件状态或临时 DOM 状态（例如：表单输入值）的列表渲染输出。</p>
<p>为了给 Vue 一个提示，以便它能跟踪每个节点的身份，从而重用和重新排序现有元素，你需要为每项提供一个唯一 key 属性。理想的 key 值是每项都有唯一 id。这个特殊的属性相当于 Vue 1.x 的 track-by ，但它的工作方式类似于一个属性，所以你需要用 v-bind 来绑定动态值（在这里使用简写）：</p>
<div>
<pre class="prettyprint linenums">&lt;div v-for="item in items" :key="item.id"&gt;<br />
  &lt;!-- 内容 --&gt;<br />
&lt;/div&gt;</pre>
</div>
<p>建议尽可能使用 v-for 来提供 key ，除非迭代 DOM 内容足够简单，或者你是故意要依赖于默认行为来获得性能提升。因为它是 Vue 识别节点的一个通用机制， key 并不特别与 v-for 关联，key 还具有其他用途，我们将在后面的指南中看到其他用途。</p>
<h2>2.ref</h2>
<p>ref如果在普通的 DOM 元素上使用，引用指向的就是 DOM 元素</p>
<p>ref如果用在子组件上，引用就指向组件实例：</p>
<p>关于 ref 注册时间的重要说明：因为 ref 本身是作为渲染结果被创建的，在初始渲染的时候你不能访问它们 - 它们还不存在！<code>$refs</code>&nbsp;也不是响应式的，因此你不应该试图用它在模板中做数据绑定。</p>
<h3>vue中的 ref 和 $refs</h3>
<div>
<div>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1089028/201710/1089028-20171027145813726-1898103104.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1089028/201710/1089028-20171027145850414-1743291129.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1089028/201710/1089028-20171027150137680-2114301928.png" /></p>
<p>如图，<code>ref</code>&nbsp;被用来给元素或子组件注册引用信息。引用信息将会注册在父组件的&nbsp;<code>$refs</code>&nbsp;对象上。如果在普通的 DOM 元素上使用，引用指向的就是 DOM 元素；如果用在子组件上，引用就指向组件实例：</p>
<p>在上面的例子中，input的引用信息为input1 ，$refs 是所有注册过的ref的一个集合，</p>
<p>console.log(this.$refs.input1)//&lt;input type="text" id="input1"&gt;<br />console.log(document.getElementById('input1'))//&lt;input type="text" id="input1"&gt;</p>
<p>这两种方法获得的都是Dom节点，而<strong>$refs相对document.getElementById的方法，会减少获取dom节点的消耗。</strong></p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1089028/201710/1089028-20171027150901476-62482316.png" /></p>
</div>
</div>
<div>
<div>
<div>
<h4>this.$refs获取不到dom的可能原因及方法解决</h4>
</div>
</div>
</div>
<div>
<div>
<p>平时我们遇到<code>this.$refs</code>获取不到dom节点，最大的可能是我们在当前组件用上了ajax/axios等方法，因为他们都是异步的，在执行顺序上，先通过this.$refs来获取dom，再通过ajax请求加载dom，所以dom还没加载完，使用this.$refs获取不到数据</p>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m96yngv8.html">java编译期优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93g7dr8.html">用Qt写软件系列五：一个安全防护软件的制作（2）</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m7pjp8.html">net中序列化读写xml</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qykkd29.html">myeclipse 2013 SR2 for&lpar;MAC&sol;WINDOWS&rpar;破解 注册过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m11x28.html">Linux nmap</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw6j139.html">Q1微信用户增长11&percnt; 微信生态圈逐渐完善</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjdpk49.html">linux下文件系统的介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/96opmyv9.html">win10 mac地址修改器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1rowj9.html">PLS-00215&colon;字符串长度限制在范围</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1llk39.html">C&num;集合之Hashtable</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkdr6z8.html">XMPP and SIP</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv16nx1q.html">react create-react-app 跨域</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rrgo48.html">dubbo&plus;zookeeper&plus;springBoot框架整合与dubbo泛型调用演示</a>
		</li>
						<li><a href="https://www.batexi.com/a/90reo349.html">9、Qt Project之简单的数据库接口</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd4dl09.html">web模拟终端博客系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j16pj09.html">BZOJ&period;3329&period;Xorequ&lpar;数位DP&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv1jrjq.html">【架构】技术-工具-平台-语言&amp;amp&semi;框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnvx0kq.html">MySql（五）：MySQL数据库安全管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv24xxq.html">web移动前端页面，jquery判断页面滑动方向</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pdl7w8.html">swift设计模式学习 - 模板方法模式</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv2eryj9.html">Oracle EBS FORM 设置块属性</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll1ve0q.html">SQL Server将一列的多行内容拼接成一行</a>
			</li>
						<li><a href="https://www.batexi.com/a/9603dm49.html">ASP&period;NET MVC之从控制器传递数据到视图方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd2yyj9.html">SQL Server 锁机制</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25ky2oq.html">好系统重装助手教你如何让win10系统快速开机</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyklgd9.html">SSL 原理及 https 配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjpx049.html">Oauth2&period;0&lbrack;笔记&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1mgmg9.html">《Java大学教程》&mdash;第8章 通过继承扩展类</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2eon19.html">51nod 1238 最小公倍数之和 V3</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjollj9.html">【CQOI2012】局部极小值</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
